Foreman - Bug #12643

Smart variable/class param free text search throws "no such column: lookup_values.value" error
12/01/2015 07:13 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: Search
Target version: 1.10.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2958
Description

When on the smart variables or smart class parameters index pages, entering any free text search fails with the following error:

SQLite3::SQLException: no such column: lookup_values.value: SELECT "lookup_keys"."puppetclass_id"
FROM "lookup_keys" WHERE "lookup_keys"."type" IN ('VariableLookupKey') AND (("lookup_keys"."key"
LIKE 'Stest%' OR "lookup_values"."value" LIKE '$test%' OR "puppetclasses"."name" LIKE 'Stest%'))
ORDER BY "lookup_keys"."key" ASC LIMIT 40 OFFSET 0

It appears that the scoped search from lookup keys to values isn't actually joining the tables.

Related issues:
Has duplicate Foreman - Bug #13034: SQL error when searching for smart class ... Duplicate 01/07/2016
Has duplicate Foreman - Bug #13105: Search in Smart Class Parameter yields PG... Duplicate 01/11/2016

Associated revisions

Revision 0e9b35eb - 12/09/2015 12:19 PM - Tomer Brisker
Fixes #12644, #12643 - Correctly authorize in lookup key index

There was a problem with the authorizer for lookup key indices that led

to problems with sorting and searching.

Because “#includes’ lazy loads the included relation, and the authorizer
didn't need the relation, it didn't load the puppetclass or the

lookup_value table. However, the search_for scope added an order_by or a
where condition to @lookup_keys, which caused the authorizer collection
to create an invalid query.

Revision 5e77d766 - 01/19/2016 08:16 AM - Tomer Brisker
Fixes #12644, #12643 - Correctly authorize in lookup key index

There was a problem with the authorizer for lookup key indices that led

to problems with sorting and searching.

Because “#includes’ lazy loads the included relation, and the authorizer
didn't need the relation, it didn't load the puppetclass or the

lookup_value table. However, the search_for scope added an order_by or a
where condition to @lookup_keys, which caused the authorizer collection
to create an invalid query.

(cherry picked from commit 0e9b35eb264ebfd7630aca7eba72213c6d5a9fal)

History

#1 - 12/07/2015 10:19 AM - Tomer Brisker
- Status changed from New to Ready For Testing
- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/2958 added
#2 - 12/09/2015 01:01 PM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 0e9b35eb264ebfd7630aca7eba72213c6d5a9fal.

#3 - 12/10/2015 02:44 AM - Dominic Cleal

- translation missing: en.field_release set to 104

#4 - 01/07/2016 04:56 AM - Dominic Cleal

- Has duplicate Bug #13034: SQL error when searching for smart class parameter added

#5 - 01/11/2016 03:35 AM - Dominic Cleal
- Has duplicate Bug #13105: Search in Smart Class Parameter yields PGError added
